%%%%%%%%%%%%%%%%%%%%%%%%%%  %%%%%%% MAIN %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run(S):- inp(G0), bfs_all(G0),goal_perm(G0,G),writeln(G),solve(G,P,1),seq(P,S), told, tell('X:/fartash/Downloads/ai/output.txt'),myprint(S).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% INPUT AND PARSING IT !! %%%%%%%%%%%%%%%%%%%%%%%

inp(GoalList):-seen,retractor,see('X:/fartash/Downloads/ai/input.txt'),readNumber(0,N),assert(n(N)),
     readNumber(0,M),assert(m(M)),readMap(Map,[],N,M,N,0),parsMap(Map,[],GoalList,-1,0,0).

readNumber(G,R):-get0(X),X<58,X>47,!,GG is G*10+X-48,readNumber(GG,R).
readNumber(G,G).
% N is not necessary
readMap([],[],_,_,0,0):-!.%seen.
readMap([Line|Map],[],N,M,MyN,0):-!,NewMyN is MyN-1,readMap(Map,Line,N,M,NewMyN,M).
readMap(Map,[X|Line],N,M,MyN,MyM):- get(X),NewMyM is MyM-1,readMap(Map,Line,N,M,MyN,NewMyM).

%Done
parsMap([],[],[],_,_,Number):-!, assert(stone_count(Number)).
%End of line
parsMap([Line|Map],[],G,MyN,_M,Number):-!,NewMyN is MyN+1,parsMap(Map,Line,G,NewMyN,0,Number).
%first Buldozer
parsMap(Map,[X|Line],G,MyN,MyM,Number):-
                                        (X==66),!,assert(holds(sitting_at(boldozer,point(MyN,MyM)),init)),
                                        NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).
%first Tracktor
parsMap(Map,[X|Line],G,MyN,MyM,Number):-
                                        (X==84),!,assert(holds(sitting_at(tracktor,point(MyN,MyM)),init)),
                                        NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).

%first Worker
parsMap(Map,[X|Line],G,MyN,MyM,Number):-
                                        (X==87),!,assert(holds(sitting_at(worker,point(MyN,MyM)),init)),
                                        NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).
%Stone    S
parsMap(Map,[X|Line],G,MyN,MyM,Number):-
                                        (X==83),!,assert(holds(stone_at(Number,point(MyN,MyM)), init)), assert(bfs_stone(Number,point(MyN,MyM))),
                                        NewNumber is Number+1,NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,NewNumber).
%Goal    G
parsMap(Map,[X|Line],[stone_at(_Unknown,point(MyN,MyM))|G],MyN,MyM,Number):-%get0(Temp),Number2 is Temp-48,
                                                                                       (X==71),!,assert(holds(empty(point(MyN,MyM)),init)),
                                                                                       NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).
%Wall   *
parsMap(Map,[X|Line],G,MyN,MyM,Number):-
                                        (X==42),!,assert(holds(wall(point(MyN,MyM)),init)),
                                        NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).
%Nothing special
parsMap(Map,[_|Line],G,MyN,MyM,Number):-assert(holds(empty(point(MyN,MyM)),init)), NewMyM is MyM+1,parsMap(Map,Line,G,MyN,NewMyM,Number).

retractor:-retractall(wall(_)),retractall(stone_at(_)),retractall(boldozer(_)),retractall(goal(_)),retractall(n(_)),retractall(m(_)).

%%%%%%%%%%%%%%%%%%%%%%% INPUT DONE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%% Heuristic 1 - Manhatan Distance %%%%%%%%%%%%%%%%%%%%%%%%%

heur1_mdist(MyN, _) :-
                 n(N), (N==MyN),!.
heur1_mdist(MyN, MyM) :-
                 m(M), (M==MyM),!,NewN is MyN+1,heur1_mdist(NewN,0).
heur1_mdist(MyN, MyM) :-
                 n(N), m(M), Inf is N+M,
                 assert(mdist(point(MyN, MyM), Inf)),
                 heur1_find_min(MyN, MyM, 0),
                 NewMyM is MyM+1,
                 heur1_mdist(MyN, NewMyM).
                 
heur1_find_min(_MyN, _MyM, SC) :-
                    stone_count(C), (C==SC), !.%, mdist(point(MyN, MyM), D), write(MyN), write(' '), write(MyM), write(' '), writeln(D).
heur1_find_min(MyN, MyM, SC) :-
                    holds(stone_at(SC,point(X,Y)),init),
                    CDist is abs(X-MyN)+abs(Y-MyM),
                    mdist(point(MyN, MyM), PDist),
                    retract(mdist(point(MyN, MyM), PDist)), BDist is min(CDist, PDist), assert(mdist(point(MyN, MyM), BDist)),
                    NewSC is SC+1,
                    heur1_find_min(MyN, MyM, NewSC).

heur1_check([], 0).

heur1_check([goal(G,_GG)|Ag], MaxDB) :-
                                    G=stone_at(_Z,point(X,Y)),
                                    !,
                                    mdist(point(X, Y), D),
                                    heur1_check(Ag, CMDB),
                                    MaxDB is CMDB + D.
                                    
heur1_check([_|Ag], MaxDB) :- heur1_check(Ag, MaxDB).

agent_count(C) :-
    findall(Agent,holds(sitting_at(Agent,point(_MyN,_MyM)),init),Agents),
    length(Agents,C).

goal_perm(G0,G0) :- agent_count(C), C \== 1, !.
goal_perm(G0,G) :-
    holds(sitting_at(_Agent,point(X,Y)),init),
    length(G0,C),
    assert(goal_count(C)),
    bfs([cell(point(X,Y),0)],[],_,goal),
    set_goal_perm(G).

set_goal_perm([]) :- \+ bfs_goal2(_Number,point(_X,_Y)),!.
set_goal_perm([GH|GT]) :-
    bfs_goal2(Number,point(X,Y)),
    GH=stone_at(Number,point(X,Y)),
    retract(bfs_goal2(Number,point(X,Y))),
    set_goal_perm(GT).

bfs_all([]).
bfs_all([stone_at(Number,point(X,Y))|G]) :-
    bfs([cell(point(X,Y),0)],[],Number,stone),
    retract(bdist(point(_A,_B),Dist)),
    assert(mdist(point(X,Y),Dist)),
    assert(bfs_goal(Number,point(X,Y))),
    bfs_all(G).

bfs([],_Mark, -1,_SG).
bfs(_Q,_Mark,_Dist,goal) :- goal_count(C), C==0,!.
bfs([cell(point(X,Y),Dist)|_Q],_Mark, Number,stone) :- bfs_stone(Number,point(X,Y)), !,
    retract(bfs_stone(Number,point(X,Y))),
    assert(bdist(point(X, Y), Dist))
    .
bfs([cell(point(X,Y),_Dist)|_Qs],_Mark, Number,goal) :- bfs_goal(Number,point(X,Y)), !,
    retract(bfs_goal(Number,point(X,Y))),
    assertz(bfs_goal2(Number,point(X, Y))),%writeln(bfs_goal2(Number,point(X, Y))),flush,
    goal_count(C),
    NC is C-1,
    retract(goal_count(C)),
    assert(goal_count(NC)),
    bfs([cell(point(X,Y),0)],[], _Number2,goal).
    
bfs([cell(point(X,Y),Dist)|Qs0],Mark0, Number,SG) :-
    get_neighs(point(X,Y),N), NDist is Dist+1,
    bfs_append(NDist,N,Qs0,Qs1,Mark0,Mark1),
    bfs(Qs1,Mark1, Number,SG).

bfs_append(_Dist,[],Qs0,Qs0,Mark0,Mark0) :- !.
bfs_append(Dist,[point(X,Y)|N],Qs0,Qs2,
           Mark0, [point(X,Y)|Mark1]) :-
    \+ member(point(X,Y),Mark0),!,
    append(Qs0,[cell(point(X,Y),Dist)],Qs1),
    bfs_append(Dist,N,Qs1,Qs2,Mark0,Mark1).

bfs_append(Dist,[point(_X,_Y)|N],Qs0,Qs1,Mark0,Mark1) :-
    bfs_append(Dist,N,Qs0,Qs1,Mark0,Mark1).

get_neighs(point(X,Y),N) :- check_neighs(point(X,Y),N,['l','r','d','u']).%['l','r','d','u']

check_neighs(point(_,_),[],[]).
check_neighs(point(X,Y),[point(A,B)|N],[HD|D]) :-
    myadjacent(point(X,Y),point(A,B),HD),
    myvalid(A,B), \+ holds(wall(point(A,B)),init), !, check_neighs(point(X,Y),N,D).
check_neighs(point(X,Y),N,[_HD|D]) :- check_neighs(point(X,Y),N,D).


%%%%%%%%%%%%%%%%%%%%%%% Useful facts & Rules %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

valid(X,Y)<-[m(M),n(N),X>?(-1),Y>?(-1),X<?N,Y<?M].

%X1,Y1 is before our move   ,X1,Y1 is always defined !
%left
adjacent(point(X1,Y1),point(X2,Y2),'L')<-[Y2 iss Y1-1,X1==?X2,valid(X1,Y1),valid(X2,Y2)].
%right
adjacent(point(X1,Y1),point(X2,Y2),'R')<-[Y2 iss Y1+1,X1==?X2,valid(X1,Y1),valid(X2,Y2)].
%up
adjacent(point(X1,Y1),point(X2,Y2),'U')<-[X2 iss X1+1,Y1==?Y2,valid(X1,Y1),valid(X2,Y2)].
%down
adjacent(point(X1,Y1),point(X2,Y2),'D')<-[X2 iss X1-1,Y1==?Y2,valid(X1,Y1),valid(X2,Y2)].

%left
adjacent2(point(X1,Y1),point(X2,Y2),'R')<-[Y2 iss Y1-1,X1==?X2,valid(X1,Y1),valid(X2,Y2)].
%right
adjacent2(point(X1,Y1),point(X2,Y2),'L')<-[Y2 iss Y1+1,X1==?X2,valid(X1,Y1),valid(X2,Y2)].
%up
adjacent2(point(X1,Y1),point(X2,Y2),'D')<-[X2 iss X1+1,Y1==?Y2,valid(X1,Y1),valid(X2,Y2)].
%down
adjacent2(point(X1,Y1),point(X2,Y2),'U')<-[X2 iss X1-1,Y1==?Y2,valid(X1,Y1),valid(X2,Y2)].

empty(Pos)<-[not(wall(Pos)),not(sitting_at(_,Pos))].

autonomous(boldozer).
autonomous(boldozer) <- [].
autonomous(tracktor).
autonomous(tracktor) <- [].
autonomous(worker).
autonomous(worker) <- [].
%n(8) <- [].
%m(8) <- [].


achieves(init,X):-holds(X,init).



primitive(sitting_at(_,_)).
primitive(stone_at(_,_)).
primitive(boldozer(_,_)).
primitive(tracktor(_,_)).
primitive(worker(_,_)).
primitive(empty(_)).

%%%%%%%%%%%%%%%%%%%%%% OUTPUT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
myvalid(X,Y):-m(M),n(N),X>(-1),Y>(-1),X<N,Y<M.
%left
myadjacent(point(X1,Y1),point(X2,Y2),'l'):-Y2 is Y1-1,X1=X2,myvalid(X1,Y1),myvalid(X2,Y2).
%right
myadjacent(point(X1,Y1),point(X2,Y2),'r'):-Y2 is Y1+1,X1=X2,myvalid(X1,Y1),myvalid(X2,Y2).
%up
myadjacent(point(X1,Y1),point(X2,Y2),'d'):-X2 is X1+1,Y1=Y2,myvalid(X1,Y1),myvalid(X2,Y2).
%down
myadjacent(point(X1,Y1),point(X2,Y2),'u'):-X2 is X1-1,Y1=Y2,myvalid(X1,Y1),myvalid(X2,Y2).


myprint([init|X]):-!,myprint(X).
myprint([end]):-!,told.
myprint([H|X]):-H=push(T,Z,Y,_,_),myadjacent(Z,Y,Jahat),!,find(T),find(Jahat),myprint(X).
myprint([H|X]):-H=move(T,Z,Y),myadjacent(Z,Y,Jahat),!,find(T),find(Jahat),myprint(X).

find(boldozer):-write('b '),!.
find(tracktor):-write('t '),!.
find(worker):-write('w '),!.
find(X):-writeln(X).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%% ACTIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% move(Ag,Pos,Pos_1) is the action of Ag(Agent) moving from Pos to Pos_1

preconditions(move(Ag,Pos,Pos_1),
    [autonomous(Ag), sitting_at(Ag,Pos), adjacent(Pos,Pos_1,_),empty(Pos_1)]).
achieves(move(Ag,_Pos,Pos_1),sitting_at(Ag,Pos_1)).
achieves(move(_Ag,Pos,_Pos_1),empty(Pos)).
deletes(move(Ag,Pos,_Pos_1),sitting_at(Ag,Pos)).
deletes(move(_Ag,_Pos,Pos_1),empty(Pos_1)).

preconditions(push(Ag,Pos,Pos_1,Number,Pos_2),
    [autonomous(Ag),stone_at(Number,Pos_1),sitting_at(Ag,Pos),adjacent(Pos,Pos_1,Jahat),adjacent(Pos_1,Pos_2,Jahat),empty(Pos_2)]).
achieves(push(Ag,_Pos,Pos_1,_Number,_Pos_2),sitting_at(Ag,Pos_1)).
achieves(push(_Ag,_Pos,_Pos_1,Number,Pos_2),stone_at(Number,Pos_2)).
achieves(push(_Ag,Pos,_Pos_1,_Number,_Pos_2),empty(Pos)).

deletes(push(Ag,Pos,_Pos_1,_Number,_Pos_2),sitting_at(Ag,Pos)).
deletes(push(_Ag,_Pos,Pos_1,Number,_Pos_2),stone_at(Number,Pos_1)).
deletes(push(_Ag,_Pos,_Pos_1,_Number,Pos_2),empty(Pos_2)).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%